library qm_tj;

import 'dart:convert';

import 'package:qm_tj/src/utils.dart';

import 'src/db.dart';
import 'src/http.dart';
import 'package:crypto/crypto.dart' as crypto;
import 'src/tj/app.dart';

class QMTJ {
  static DB _db;
  static App _app;

  static void debug() {
    Utils.debug();
  }

  static init() async {
    _db.init();
    _app = App(_db);
    Future.delayed(Duration(seconds: 5)).then((value) {
      uploadPageTj();
    });
  }

  /// APP 可见
  static void onAppResume({Map<String, dynamic> extras}) async {
    _app.onResume(extras: extras);
  }

  /// APP 不可见
  static void onAppPause() async {
    _app.onPause();
  }

  /// PAGE 可见
  static void pageAppear(
      {int source,
      String pageId,
      String lastPageId,
      Map<String, dynamic> extras}) async {
    // String extrasStr = json.encode(extras);
    // String id = _md5("${pageId}_${lastPageId}_$extrasStr");
    // int disappearTime = 0;
    // int appearTime = _getDateNow();
    // Map<String, dynamic> map = {
    //   "id": id,
    //   "source": source,
    //   "page_id": pageId,
    //   "last_page_id": lastPageId,
    //   "appear_time": appearTime,
    //   "disappear_time": disappearTime,
    //   "extras": extrasStr,
    // };
    // await _db.ready;
    // log("pageAppear", map);
    // await _db.db.insert("page_tj", map);
  }

  /// PAGE 不可见
  static void pageDisappear(
      {String pageId, String lastPageId, Map<String, dynamic> extras}) async {
    // String extrasStr = json.encode(extras);
    // String id = _md5("${pageId}_${lastPageId}_$extrasStr");
    // int disappearTime = _getDateNow();
    // Map<String, dynamic> map = {
    //   "id": id,
    //   "page_id": pageId,
    //   "last_page_id": lastPageId,
    //   "disappear_time": disappearTime,
    //   "extras": extrasStr,
    // };
    // await _db.ready;
    // log("pageDisappear", map);
    // await _db.db.update(
    //     "page_tj",
    //     {
    //       "disappear_time": disappearTime,
    //     },
    //     where: "id = ?  and disappear_time = 0",
    //     whereArgs: [id]);
  }

  /// 点击
  /// [pageId] 页面id
  /// [clickId] 点击id
  /// [extras] 点击参数
  static void tap(
      {int source,
      String pageId,
      String clickId,
      Map<String, dynamic> extras}) async {
    // int clickTime = _getDateNow();
    // String extrasStr = json.encode(extras);
    // String id = _md5("${pageId}_${clickId}_${extrasStr}_${clickTime}");
    // Map<String, dynamic> map = {
    //   "id": id,
    //   "source": source,
    //   "page_id": pageId,
    //   "click_id": clickId,
    //   "click_time": clickTime,
    //   "extras": extrasStr,
    // };
    // await _db.ready;
    // log("tap", map);
    // await _db.db.insert("tap_tj", map);
  }

  /// 曝光
  /// [pageId] 页面id
  /// [exposureId] 曝光id
  /// [extras] 曝光参数
  static void exposure(
      {int source,
      String pageId,
      String exposureId,
      Map<String, dynamic> extras}) async {
    // int exposureTime = _getDateNow();
    // String extrasStr = json.encode(extras);
    // String id = _md5("${pageId}_${exposureId}_${extrasStr}_${exposureTime}");
    // Map<String, dynamic> map = {
    //   "id": id,
    //   "source": source,
    //   "page_id": pageId,
    //   "exposure_id": exposureId,
    //   "exposure_time": exposureTime,
    //   "extras": extrasStr,
    // };
    // await _db.ready;
    // log("exposure", map);
    // await _db.db.insert("exposure_tj", map);
  }

  // 上传页面统计
  static void uploadPageTj() async {
    //   await _db.ready;
    //   List<Map> list = await _db.db.query("page_tj", limit: 100, offset: 0);
    //   if (list.length == 0) {
    //     return;
    //   }
    //   List<String> ids = [];
    //   list = list.map((e) {
    //     var item = {
    //       "app_version": '0.0.1',
    //       "app_channel": "APP渠道",
    //       "devices_id": '3A26610FFE43D5838DDE7A40BA2E3E2C',
    //       "inter": '4G',
    //       "source": e['source'],
    //       "page_id": e['page_id'],
    //       "last_page_id": e['last_page_id'],
    //       "come_time": e['appear_time'],
    //       "out_time": e['disappear_time'],
    //       "extras": json.decode(e['extras'])
    //     };
    //     ids.add(e['id']);
    //     Map project = {
    //       "event_name": "page_scan",
    //       "app": "xx",
    //       "event_info": item
    //     };
    //     return project;
    //   }).toList();
    //   print({"project": json.encode(list)});
    // }

    // static Map<String, dynamic> getCommonParams() {
    //   return {
    //     "inter": "网络情况",
    //     "app_channel": "APP渠道",
    //     "app_version": "APP版本",
    //     "device_id": "设备ID",
    //     "source": "来源",
    //   };
  }

  /// 获取当前时间戳，单位:秒
  static int _getDateNow() {
    int now = (DateTime.now().millisecondsSinceEpoch / 1000).floor();
    return now;
  }

  // md5编码
  static String _md5(String data) {
    var bytes = utf8.encode(data);
    var digest = crypto.md5.convert(bytes);
    return digest.toString();
  }
}
